/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.mytch.droidracer;

/**
 *
 * @author Mytchel
 */

import android.content.Context;
import android.graphics.*;
import android.util.Log;
import android.view.*;
import java.util.Random;


public class MainGamePanel extends SurfaceView implements SurfaceHolder.Callback {
    
    private static final String TAG = MainGamePanel.class.getSimpleName();
    
    public MainLoop thread;
    public float[] x = new float[10];
    public float[] y = new float[10];
    public int di;
    public Paint p = new Paint();
    public boolean play = false;
    public boolean finish = false;
    public int score = 0;
    public int color = 0xFF0099FF;
    
    public float[] food = {0, 0};
    
    private Random r = new Random();
    
    public MainGamePanel(Context context) {
        super(context);
        getHolder().addCallback(this);
        
        thread = new MainLoop(getHolder(), this);
        
        setFocusable(true);
        setWillNotDraw(false);
        
        float width = getWidth();
        Log.d(TAG, "Height = " + width );
        
        for (int i = 9; i > 0; i--) x[i] = y[i] = -600;
        y[0] = r.nextInt(300 / 10) * 10;
        x[0] = r.nextInt(200 / 10) * 10;
        di = r.nextInt(4);
        food[0] = r.nextInt(300 / 10) * 10;
        food[1] = r.nextInt(200 / 10) * 10;
        
    }
   
    public void surfaceChanged(SurfaceHolder holder, int format, int width, int height) {
        
    }
    public void surfaceCreated(SurfaceHolder holder) {
        thread.setRunning(true);
        thread.start();
    }
    public void surfaceDestroyed(SurfaceHolder holder) {
        boolean retry = true;
        while (retry) {
            try {
                thread.join();
                retry = false;
            } catch (InterruptedException e) {}
        }
    }
    @Override
    public boolean onTouchEvent(MotionEvent event) {
        if (event.getAction() == MotionEvent.ACTION_DOWN) {
            if (event.getY() < 50 && !finish) {
                if (di != 2) {
                    di = 1;
                }
            } 
            if (event.getY() > getHeight() - 50 && !finish) {
                if (di != 1) {
                    di = 2;
                }
            }
            if (event.getX() > getWidth() - 50 && event.getY() > 50 && event.getY() < getHeight() - 50 && !finish) {
                if (di != 4) {
                    di = 3;
                }
            }
            if (event.getX() < 50 && event.getY() > 50 && event.getY() < getHeight() - 50 && !finish) {
                if (di != 3) {
                    di = 4;
                }
            }
            if (finish) {
                
                thread.setRunning(false);
                boolean retry = true;
                while (retry) {
                    try {
                        thread.join();
                        retry = false;
                    } catch (InterruptedException e) {}
                }
            
                thread = new MainLoop(getHolder(), this);
                thread.setRunning(true);
                thread.start();
        
                setFocusable(true);
                setWillNotDraw(false);
                score = 0;
                y = new float[10];
                x = new float[10];
                for (int i = 9; i > 0; i--) x[i] = y[i] = -600;
                y[0] = (float)(r.nextInt((int)(getHeight() / 10)) * 10);
                x[0] = (float)(r.nextInt((int)(getWidth()) / 10) * 10);
                di = r.nextInt(4);
                finish = false;
            }
        }
        
        return super.onTouchEvent(event);
    }
    @Override
    protected void onDraw(Canvas canvas) {
        if (play) {
            
            if (di == 1 && !finish) y[0] -= 10;
            if (di == 2 && !finish) y[0] += 10;
            if (di == 3 && !finish) x[0] += 10;
            if (di == 4 && !finish) x[0] -= 10;
            
            if (x[0] > (float) getWidth()) x[0] = 0;
            if (x[0] < 0) x[0] = getWidth();
            if (y[0] > (float) getHeight()) y[0] = 0;
            if (y[0] < 0) y[0] = getHeight();
            
            
            for (int i = x.length - 1; i > 0; i--) {
                if (x[0] == x[i] && y[0] == y[i]) {// lost?
                    finish = true;
                }
                p.setColor(color);
                canvas.drawRect(x[i], y[i], x[i] + 10, y[i] + 10, p);
                if (!finish) {
                    x[i] = x[i - 1];
                    y[i] = y[i - 1];
                }
                
            }
            p.setColor(0xFFFFFFFF);
            canvas.drawRect(x[0], y[0], x[0] + 10, y[0] + 10, p);
            p.setColor(0xFFFFFF00);
            canvas.drawRect(food[0], food[1], food[0] + 10, food[1] + 10, p);
            if (x[0] == food[0] && y[0] == food[1]) { // player got food
                score++;
                food[0] = (float)(r.nextInt((int)(getHeight() / 10)) * 10);
                food[0] = (float)(r.nextInt((int)(getWidth()) / 10) * 10);
                float[] a = x;
                float[] b = y;
                x = new float[score * 3 + 20];
                y = new float[score * 3 + 20];
                for (int i = 0; i < x.length; i++) x[i] = y[i] = -500;
                for (int i = 0; i < a.length; i++) {
                    x[i] = a[i];
                    y[i] = b[i];
                }
            }
                     
        }
        if (finish) {
            p.setColor(0xFFFFFFFF);
            p.setTextSize(20.0F);
            canvas.drawText("Press Anywere To Restart", (getWidth() / 2) - 100, (getHeight() / 2) - 20, p);
            canvas.drawText("Your score = " + score, (getWidth() / 2) - 75, (getHeight() / 2) + 10, p);
        }
    }
}
